!Code_Asterの計算結果の軸方向応力をgnuplot用にまとめる
!ついでに、変位の平均値も求める。

! 使い方：
!   見たい断面をmeshでグルーピングしてから、Code_Asterで計算。
!   その後、Paravisでrmedファイルを開き、見たい断面だけにチェックを入れ、
!   Select Points Through の枠で囲って選択。
!   断面を選択したら、Fileters の Data Analysis の Plot Data を押す。
!   すると、グラフが描かれるので、その右上の「日」みたいなアイコンを押す。
!   一番下の Spredsheet View を押すと表が現れるので、
!   この状態で File の Export... からcsvにエクスポート。

!   $ ./danmen<hoge.csv>hoge.d
!   gnuplot> splot 'hoge.d' 

implicit none
integer             :: nodes=178 !断面の節点数(csvファイルの行数-1)    
real(8),allocatable :: x(:),y(:),z(:)
real(8),allocatable :: u(:),v(:),w(:)
real(8),allocatable :: sxx(:),syy(:),szz(:),sxy(:),syz(:),sxz(:)
real rcut
integer icut,i
allocate(x(nodes),y(nodes),z(nodes))
allocate(u(nodes),v(nodes),w(nodes))
allocate(sxx(nodes),syy(nodes),szz(nodes)&
         &,sxy(nodes),syz(nodes),sxz(nodes))

!csvファイルの読み込み
read(*,'()')
do i=1,nodes
   read(*,*) icut,u(i),v(i),w(i),rcut,rcut,rcut,rcut,rcut,rcut,rcut&
!   read(*,*) u(i),v(i),w(i),rcut,rcut,rcut,rcut,rcut,rcut,rcut&
            &,rcut,rcut,rcut,sxx(i),syy(i),szz(i),sxy(i),syz(i),sxz(i)&
            &,rcut,rcut,rcut,x(i),y(i),z(i),icut,icut
enddo

!節点変位の平均を計算(方向(x:u,y:v,z:w)は書き換える)
print*,'# 変位:',sum(v)/size(v)
print'()'

!gnuplot用に書き出し(座標とその並びは書き換える)
do i=1,nodes
   print*,x(i),y(i),szz(i)
enddo

end
